summaryrefslogtreecommitdiff
path: root/tests/misc/stty-invalid
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-09-11 23:30:49 +0200
committerJim Meyering <jim@meyering.net>2007-09-15 08:40:39 +0200
commit0539705768992ebcc290bc859f64e27898c7f958 (patch)
tree9e49d8f9aca7097cdff462da3e67cbc2ac941cda /tests/misc/stty-invalid
parent44629cf147ba5c3827b5252e36ce50ce447b36b8 (diff)
downloadcoreutils-0539705768992ebcc290bc859f64e27898c7f958.tar.xz
Move all tests from test/{od,sha1sum,shred,stty} to tests/misc/.
Reflect these renamings: od/od-N misc/od-N od/x8 misc/od-x8 sha1sum/basic-1 misc/sha1sum sha1sum/sample-vec misc/sha1sum-vec shred/exact misc/shred-exact shred/remove misc/shred-remove stty/basic-1 misc/stty stty/invalid misc/stty-invalid stty/row-col-1 misc/stty-row-col * tests/misc/Makefile.am (TESTS): Add the new files. * tests/Makefile.am (SUBDIRS): Remove the dir names. * tests/od, tests/sha1sum, tests/shred, tests/stty: Remove the directories. * configure.ac (AC_CONFIG_FILES): Remove the corresponding Makefile names.
Diffstat (limited to 'tests/misc/stty-invalid')
-rwxr-xr-xtests/misc/stty-invalid49
1 files changed, 49 insertions, 0 deletions
diff --git a/tests/misc/stty-invalid b/tests/misc/stty-invalid
new file mode 100755
index 000000000..a2a636d06
--- /dev/null
+++ b/tests/misc/stty-invalid
@@ -0,0 +1,49 @@
+#!/bin/sh
+# Ensure that stty diagnoses invalid inputs, rather than silently misbehaving.
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ stty --version
+fi
+
+# Make sure there's a tty on stdin.
+. $srcdir/../input-tty
+. $srcdir/../test-lib.sh
+
+fail=0
+
+saved_state=`stty -g` || fail=1
+stty $saved_state || fail=1
+
+# Before coreutils-6.10, if stty were given an argument with 35 colons
+# separating 36 hexadecimal strings, stty would fail to diagnose as invalid
+# any number that was out of range as long as sscanf happened to
+# overflow/wrap it back into the range of the corresponding type (either
+# tcflag_t or cc_t).
+
+# For each of the following, before 6.10, stty would fail to
+# diagnose the error on at least Solaris 10.
+hex_2_64=10000000000000000
+stty `echo $saved_state |sed 's/^[^:]*:/'$hex_2_64:/` 2>/dev/null && fail=1
+stty `echo $saved_state |sed 's/:[0-9a-f]*$/:'$hex_2_64/` 2>/dev/null && fail=1
+
+# Just in case either of the above mistakenly succeeds (and changes
+# the state of our tty), try to restore the initial state.
+stty $saved_state || fail=1
+
+(exit $fail); exit $fail